function Briefing()
	ObjectiveChanged(1, 0);
	SwitchWeather(1);
	Suicide();
end;

function Objective2()
	if ( GetNUnitsInArea(1, "Ambush") == 0) then
		SetIGlobalVar("temp.template01.objective.2", 1);
		ObjectiveChanged(2, 1);
		Suicide();
	end;
end;

function Objective3()
	if ( GetNUnitsInArea(1, "Hill") == 0) then
		SetIGlobalVar("temp.template01.objective.3", 1);
		ObjectiveChanged(3, 1);
		Suicide();
	end;
end;

function Objective4()
	if ( GetNUnitsInArea(1, "Ravine") == 0) then
		SetIGlobalVar("temp.template01.objective.4", 1);
		ObjectiveChanged(4, 1);
		Suicide();
	end;
end;

function Objective5()
	if ( GetNUnitsInScriptGroup(1001) > 0) then
		RunScript( "Object5");
		Suicide();
	end;
end;	

function Object5()
	if ( GetNUnitsInArea(1, "Warehouse") == 0) then
		SetIGlobalVar("temp.template01.objective.5", 1);
		ObjectiveChanged(5, 1);
		Suicide();
	end;
end;

function Objective6()
	if ( GetNUnitsInScriptGroup(1002) > 0) then
		RunScript( "Object6", 1000);
		Suicide();
	end;
end;

function Object6()
	if ( GetNUnitsInArea(1, "Blockhouse1") == 0) then
		SetIGlobalVar("temp.template01.objective.6", 1);
		ObjectiveChanged(6, 1);
		Suicide();
	end;	
end;

function Objective7()
	if ( GetNUnitsInScriptGroup(1003) > 0) then
		RunScript( "Object7", 1000);
		Suicide();
	end;
end;	

function Object7()
	if ( GetNUnitsInArea(1, "Blockhouse2") == 0) then
		SetIGlobalVar("temp.template01.objective.7", 1);
		ObjectiveChanged(7, 1);
		Suicide();
	end;
end;

function RevealObjective2()
	ObjectiveChanged(2, 0);
	Suicide();
end;

function RevealObjective3()
	ObjectiveChanged(3, 0);
	Suicide();
end;

function RevealObjective4()
	ObjectiveChanged(4, 0);
	Suicide();
end;

function RevealObjective5()
	if (GetNUnitsInScriptGroup(1001) > 0) then
		ObjectiveChanged(5, 0);
		Suicide();
	end;
end;

function RevealObjective6()
	if (GetNUnitsInScriptGroup(1002) > 0) then
		ObjectiveChanged(6, 0);
		Suicide();
	end;
end;

function RevealObjective7()
	if (GetNUnitsInScriptGroup(1003) > 0) then
		ObjectiveChanged(7, 0);
		Suicide();
	end;
end;

function ToWin()
	if ( (GetIGlobalVar("temp.template01.objective.2", 0) * GetIGlobalVar("temp.template01.objective.3", 0) * GetIGlobalVar("temp.template01.objective.4", 0) * GetIGlobalVar("temp.template01.objective.5", 0)) == 1) then
		Win(0);
		Suicide();
	end;
end;

function ToWin1()
	if ( (GetIGlobalVar("temp.template01.objective.2", 0) * GetIGlobalVar("temp.template01.objective.3", 0) * GetIGlobalVar("temp.template01.objective.4", 0) * GetIGlobalVar("temp.template01.objective.6", 0)) == 1) then
		Win(0);
		Suicide();
	end;
end;

function ToWin2()
	if ( (GetIGlobalVar("temp.template01.objective.2", 0) * GetIGlobalVar("temp.template01.objective.3", 0) * GetIGlobalVar("temp.template01.objective.4", 0) * GetIGlobalVar("temp.template01.objective.7", 0)) == 1) then
		Win(0);
		Suicide();
	end;
end;

function TobeDefeated()
	if (GetNUnitsInParty(0) <= 5) then
		ObjectiveChanged(0, 0);
		RunScript( "Lost", 5000);
		Suicide();
	end;
end;

function Lost()
	Loose();
	Suicide();
end;

function DeployGerTrps0()
	LandReinforcement( RandomInt(3)+101 );
	Suicide();
end;

function DeployGerTrps2()
	LandReinforcement( RandomInt(3)+201 );
	Suicide();
end;

function DeployGerTrps3()
	LandReinforcement( RandomInt(3)+301 );
	Suicide();
end;

function DeployGerTrps4()
	LandReinforcement( RandomInt(3)+401 );
	Suicide();
end;

function DeployGerTrps5()
	LandReinforcement( RandomInt(3)+501 );
	Suicide();
end;

function Pz3()
	if (GetNUnitsInArea (0, "Pz3") > 0) then
		LandReinforcement(601);
		Suicide();
	end;
end;

function Pz4()
	if (GetNUnitsInArea (0, "Pz4") > 0) then
		LandReinforcement(603);
		Suicide();
	end;
end;	

function BlockHouse()
	LandReinforcement( RandomInt(3)+1001 );
	Suicide();
end;

function GarInf0()
	if (GetNUnitsInScriptGroup(1001) > 0) then
		LandReinforcement(1006);
		LandReinforcement(1015);
		Cmd(6,1006,1001);
		Suicide();
	end;
end;	
		
function GarInf1()
	if (GetNUnitsInScriptGroup(1002) > 0) then
		LandReinforcement(1005);
		LandReinforcement(1016);
		Cmd(6,1005,1002);
		Suicide();
	end;
end;	

function GarInf2()
	if (GetNUnitsInScriptGroup(1003) > 0) then
		LandReinforcement(1004);
		LandReinforcement(1017);
		Cmd(6,1004,1003);
		Suicide();
	end;
end;

function Tankrush0()
	if (GetNScriptUnitsInArea (401, "DF401") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF401") > 0) then
			ChangeFormation(401,3);
			Cmd(3,401,11111,11800);
			Suicide();
		end;	
	end;
end;

function Tankrush1()
	if (GetNScriptUnitsInArea (402, "DF402") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF402") > 0) then
			ChangeFormation(402,3);
			Cmd(3,402,13000,13500);
			RunScript( "Retreat402", 5000);
			RunScript( "Retreat402a", 5000);
			RunScript( "Retreat402b", 5000); 
			Suicide();
		end;
	end;
end;

function Retreat402()
	if (GetNScriptUnitsInArea (103, "DF405") > 0) then
		if (GetNScriptUnitsInArea (303, "DF405") == 0) then
			Cmd(3,402,12200,8600); QCmd(3,402,12250,8650);
			Suicide();
		end;	
	else
		if (GetNScriptUnitsInArea (102, "DF401") > 0) then
			Cmd(3,402,10500,11400); QCmd(3,402,10600,11450);
			Suicide();
		end;
	end;
end;	

function Retreat402a()
	if (GetNScriptUnitsInArea (101, "DF403") > 0) then
		Cmd(3,402,13500,10400); QCmd(3,402,13550,10450);
		Suicide();
	end;
end;

function Retreat402b()
	if (GetNScriptUnitsInArea (103, "DF405") > 0) then
		if (GetNScriptUnitsInArea (303, "DF405") == 0) then
			Cmd(3,402,13500,10600); QCmd(3,402,13550,10450);
			Suicide();
		end;	
	end;
end;

function Rally402()
	if (GetNScriptUnitsInArea (402, "Rally403") > 0) then
		ChangeFormation(402,2);
		RunScript( "DFALL402", 5000);
		RunScript( "DFALL402a", 5000);
		Suicide();
	end;	
end;

function DFALL402()
	if ((GetSquadInfo(402) == 2) and (GetNScriptUnitsInArea (402, "DF401") > 0)) then
		if (GetNScriptUnitsInArea (2100, "DF401") > 0) then
			ChangeFormation(402,3);
			Cmd(3,402,11111,11800);
			Suicide();
		end;
	else
		if ((GetSquadInfo(402) == 2) and (GetNScriptUnitsInArea (402, "DF403") > 0)) then
			if (GetNScriptUnitsInArea (2100, "DF403") > 0) then
				ChangeFormation(402,3);
				Cmd(3,402,13400,10800);
				Suicide();
			end;
		end;
	end;
end;	

function DFALL402a()
	if ((GetSquadInfo(402) == 2) and (GetNScriptUnitsInArea (402, "DF405") > 0)) then
		if (GetNScriptUnitsInArea (2100, "DF405") > 0) then
			ChangeFormation(402,3);
			Cmd(3,402,13600,10500);
			Suicide();
		end;
	end;
end;

function Tankrush2()
	if (GetNScriptUnitsInArea (403, "DF403") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF403") > 0) then
			ChangeFormation(403,3);
			Cmd(3,403,13400,10800);
			Suicide();
		end;	
	end;
end;

function DF301()
	if (GetNScriptUnitsInArea (301, "DF301") > 0) then
		RunScript( "Charge301", 1000);
		Suicide();
	end;
end;

function Charge301()
	if (GetNScriptUnitsInArea (2100, "DF301") > 0) then
		ChangeFormation(301,3);
		Cmd(3,301,14400,7250); QCmd(3,301,14800,6750);
		Suicide();
	end;	
end;

function DF302()
	if (GetNScriptUnitsInArea (302, "DF302") > 0) then
		RunScript( "Charge302", 1000);
		Suicide();
	end;
end;

function Charge302()
	if (GetNScriptUnitsInArea (2100, "DF302") > 0) then
		ChangeFormation(302,3);
		Cmd(3,302,10500,7500); QCmd(3,302,10900,6750);
		Suicide();
	end;	
end;

function DF303()
	if (GetNScriptUnitsInArea (303, "DF405") > 0) then
		RunScript( "Charge303", 1000);
		Suicide();
	end;
end;	

function Charge303()
	if (GetNScriptUnitsInArea (2100, "DF405") > 0) then
		ChangeFormation(303,3);
		Cmd(3,303,12000,9250); QCmd(3,303,12100,8500);
		Suicide();
	end;	
end;

function DF201()
	if (GetNScriptUnitsInArea (201, "DF201") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF201") > 0) then
			ChangeFormation(201,3);
			Cmd(3,201,5800,9400); QCmd(3,201,5800,8700);
			Suicide();
		end;	
	end;
end;

function DF202()
	if (GetNScriptUnitsInArea (202, "DF202") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF202") > 0) then
			ChangeFormation(202,3);
			Cmd(3,202,6800,10700); QCmd(3,202,7200,10300);
			Suicide();
		end;	
	end;
end;

function DF203()
	if (GetNScriptUnitsInArea (203, "DF203") > 0) then
		if (GetNScriptUnitsInArea (2100, "DF203") > 0) then
			ChangeFormation(203,3);
			Cmd(3,203,7100,9500); QCmd(3,203,6500,6900);
			Suicide();
		end;	
	end;
end;

function Morale200()
	if ((GetNUnitsInScriptGroup(201) > 0) or (GetNUnitsInScriptGroup(202) > 0) or (GetNUnitsInScriptGroup(203) > 0)) then
		RunScript( "ChkMorale300", 1000);
		Suicide();
	end;
end;

function ChkMorale200()
	if ((GetNUnitsInScriptGroup(201) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(202) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(203) <= RandomInt(3)+0)) then
		KillScript( "DF301");
		KillScript( "DF302");
		KillScript( "DF303");
		ChangeFormation(201,3);
		ChangeFormation(202,3);
		ChangeFormation(203,3);
		Cmd(0,201,7400,5400);
		Cmd(0,202,7400,5400);
		Cmd(0,203,7400,5400);
		Suicide();
	end;
end;	

function Morale300()
	if ((GetNUnitsInScriptGroup(301) > 0) or (GetNUnitsInScriptGroup(302) > 0) or (GetNUnitsInScriptGroup(303) > 0)) then
		RunScript( "ChkMorale300", 1000);
		Suicide();
	end;
end;

function ChkMorale300()
	if ((GetNUnitsInScriptGroup(301) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(302) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(303) <= RandomInt(3)+0)) then
		KillScript( "DF301");
		KillScript( "DF302");
		KillScript( "DF303");
		ChangeFormation(301,3);
		ChangeFormation(302,3);
		ChangeFormation(303,3);
		Cmd(0,301,15500,2900);
		Cmd(0,302,15500,2900);
		Cmd(0,303,15500,2900);
		Suicide();
	end;
end;	
function DF710()
	if (GetNScriptUnitsInArea(2100, "DF710") > 0) then
		ChangeFormation(710,3);
		Cmd(3,710,9600,6400); QCmd(3,710,8700,6000);
		Suicide();
	end;
end;	

function Morale710()
	if (GetNUnitsInScriptGroup(710) <= RandomInt(3)+0) then
		KillScript( "DF710");
		ChangeFormation(710,3);
		Cmd(0,710,1170,9150); QCmd(6,710,1010);
		Suicide();
	end;
end;

function Morale400()
	if ((GetNUnitsInScriptGroup(401) > 0) or (GetNUnitsInScriptGroup(402) > 0) or (GetNUnitsInScriptGroup(403) > 0)) then
		RunScript( "ChkMorale400", 1000);
		Suicide();
	end;
end;

function ChkMorale400()
	if ((GetNUnitsInScriptGroup(401) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(402) <= RandomInt(3)+0) and (GetNUnitsInScriptGroup(403) <= RandomInt(3)+0)) then
		KillScript( "Rally402");
		KillScript( "DFALL402");
		KillScript( "DFALL402a");
		KillScript( "Retreat402");
		KillScript( "Retreat402a");
		KillScript( "Retreat402b");
		ChangeFormation(401,3);
		ChangeFormation(402,3);
		ChangeFormation(403,3);
		Cmd(0,401,13000,6000);
		Cmd(0,402,13000,6000);
		Cmd(0,403,13000,6000);
		Suicide();
	end;
end;	

function DF501()
	if (GetNScriptUnitsInArea (501, "DF501") > 0) then
		RunScript( "Charge501", 1000);
		Suicide();
	end;
end;	

function Charge501()
	if (GetNScriptUnitsInArea (2100, "DF501") > 0) then
		ChangeFormation(501,3);
		Cmd(3,501,14300,1700); QCmd(3,501,14600,1600);
		Suicide();
	end;	
end;

function DF502()
	if (GetNScriptUnitsInArea (502, "DF502") > 0) then
		RunScript( "Charge502", 1000);
		Suicide();
	end;
end;	

function Charge502() 
	if (GetNScriptUnitsInArea (2100, "DF502") > 0) then
		ChangeFormation(502,3);
		Cmd(3,502,12300,900); QCmd(3,502,12700,660);
		Suicide();
	end;	
end;

function DF503()
	if (GetNScriptUnitsInArea (503, "DF503") > 0) then
		RunScript( "Charge503", 1000);
		Suicide();
	end;
end;	

function Charge503()
	if (GetNScriptUnitsInArea (2100, "DF503") > 0) then
		ChangeFormation(503,3);
		Cmd(3,503,1900,4250); QCmd(3,503,1850,3600);
		Suicide();
	end;	
end;

function Patrol702()
local ScriptAreas = {};
	ScriptAreas[701] = "center_artil";
	ScriptAreas[702] = "center_sm";
	ScriptAreas[703] = "center_station";
	ScriptAreas[704] = "center_base";

local coeffs = {};
	coeffs[701] = 1448;
	coeffs[702] = 1448;
	coeffs[703] = 1448;
	coeffs[704] = 800;

local delays = {};
	delays[701] = 16000;
	delays[702] = 16000;
	delays[703] = 16000;
	delays[704] = 8000;

local ACTION_SWARM = 3;
local PatrolID = 702;
local vector = {x = 0, y = 0};
local center = {x = 0, y = 0};

	if ( GetNUnitsInScriptGroup(PatrolID) <= 0) then Suicide(); end;
	center.x, center.y = GetScriptAreaParams( ScriptAreas[PatrolID] ); -- center of patrol area

	if ( GetIGlobalVar( "temp.got.coords" .. PatrolID, 0) == 0) then
		vector.x, vector.y = GetObjCoord(PatrolID); -- starting coordinates

		vector.x = vector.x - center.x; -- relative vector
		vector.y = vector.y - center.y;

		vector = norm( vector );

		vector.x = vector.x * coeffs[PatrolID];
		vector.y = vector.y * coeffs[PatrolID];

		SetIGlobalVar( "temp.got.coords" .. PatrolID, 1);
		SetIGlobalVar( "temp.ccw" .. PatrolID, RandomInt(2));
	else
		vector.x = GetFGlobalVar( "temp.vector" .. PatrolID .. ".x", 0);
		vector.y = GetFGlobalVar( "temp.vector" .. PatrolID .. ".y", 0);
	end;

	local ccw = GetIGlobalVar( "temp.ccw" .. PatrolID, 0);

	vector = rot45( vector, ccw );

	if (CheckMapBounds( vector, center ) == 1) then -- if coord is out of map bounds
		ccw = 1 - ccw;
		SetIGlobalVar( "temp.ccw" .. PatrolID, ccw );
		vector = rot90( vector, ccw ); -- then rotate vector back
	end;

	Cmd (ACTION_SWARM, PatrolID, vector.x + center.x, vector.y + center.y);

	SetFGlobalVar( "temp.vector" .. PatrolID .. ".x", vector.x);
	SetFGlobalVar( "temp.vector" .. PatrolID .. ".y", vector.y);

	RunScript( "Patrol" .. PatrolID .. "I", delays[PatrolID] + RandomInt(4000));
	Suicide();

end;

----------------------------
function CheckMapBounds( ...)
local vec = arg[1];
local center = arg[2];
local xmax, ymax = GetMapSize(); -- get map bounds

	if ( ((vec.x + center.x) <= 0) or ((vec.y + center.y) <= 0) or ((vec.x + center.x) >= xmax) or ((vec.y + center.y) >= ymax)) then
		return 1;
	end;

	return 0;
end;

----------------------------
function rot90( ... )
local vec = arg[1];
local ccw = arg[2];

	if ( ccw == 0) then
		ccw = -1;
	else
		ccw = 1;
	end;

	local x1 = vec.y * ccw;
	local y1 = vec.x * ( -ccw);

	return {x = x1, y = y1};
end;
----------------------------
function rot45( ... )
local sqrt2div2 = 0.7071;
local vec = arg[1];
local ccw = arg[2];

	if ( ccw == 0) then
		ccw = -1;
	else
		ccw = 1;
	end;

	local x1 = vec.x * sqrt2div2 + vec.y * ccw * sqrt2div2;
	local y1 = vec.x * (- ccw * sqrt2div2) + vec.y * sqrt2div2;

	return {x = x1, y = y1};
end;

----------------------------
function norm( ... )
	local vec = arg[1];
	local len1 = len (vec);

	local x1 = vec.x / len1;
	local y1 = vec.y / len1;

	return {x = x1, y = y1};
end;

----------------------------
function len( ... )
	local vec = arg[1];

	return sqrt( vec.x * vec.x + vec.y * vec.y );
end;

----------------------------
function sqrt( x)
local ITNUM = 4;
local sp = 0
local i = ITNUM;
local inv = 0;
local a, b;
	if ( x <= 0) then return 0; end;

	if ( x < 1) then
		x = 1 / x;
		inv = 1;
	end;

	while ( x > 16) do
		sp = sp + 1;
		x = x / 16;
	end;

	a = 2;
-- Newtonian algorithm
	while (i > 0) do
		b = x / a;
		a = a + b;
		a = a * 0.5;
		i = i - 1;
	end;
--
	while ( sp > 0) do
		sp = sp - 1;
		a = a * 4;
	end;

	if ( inv == 1) then
		a = 1 / a;
	end;
	return a;
end;
----------------------------

function Patrol702I()
	RunScript( "Patrol702", 1000);
	Suicide();
end;

function Morale702()
	if (GetNUnitsInScriptGroup(702) <= RandomInt(4)+0) then
		KillScript( "Patrol702");
		KillScript( "Patrol702I");
		Cmd(0,702,2800,1500);
		Suicide();
	end;
end;

function Supply()
	if  ((GetIGlobalVar("temp.template01.objective.2", 0) * GetIGlobalVar("temp.template01.objective.3", 0)) == 1) then
		LandReinforcement(3001);
		LandReinforcement(3200);
		Suicide();
	end;
end;

function LastHope()
	if (GetNUnitsInScriptGroup(2100) <= 5) then
		LandReinforcement( RandomInt(3)+2200 );
		Suicide();
	end;
end;
	
function Init()
	RunScript( "Briefing", 1000);	
	RunScript( "RevealObjective2", 3000);
	RunScript( "RevealObjective3", 6000);
	RunScript( "RevealObjective4", 9000);
	RunScript( "RevealObjective5", 15000);
	RunScript( "RevealObjective6", 15000);
	RunScript( "RevealObjective7", 15000);
	RunScript( "Objective2", 10000);
	RunScript( "Objective3", 5000);
	RunScript( "Objective4", 5000);
	RunScript( "Objective5", 5000);
	RunScript( "Objective6", 5000);
	RunScript( "Objective7", 5000);
	RunScript( "ToWin", 10000);
	RunScript( "ToWin1", 10000);
	RunScript( "ToWin2", 10000);
	RunScript( "TobeDefeated" , 5000);
	RunScript( "DeployGerTrps0", 500); 
	RunScript( "DeployGerTrps1", 500);
	RunScript( "DeployGerTrps2", 500);
	RunScript( "DeployGerTrps3", 500);
	RunScript( "DeployGerTrps4", 500);
	RunScript( "DeployGerTrps5", 500);
	RunScript( "BlockHouse", 500);
	RunScript( "GarInf0", 1000);
	RunScript( "GarInf1", 1000);
	RunScript( "GarInf2", 1000);
	RunScript( "Pz3", 1000);
	RunScript( "Pz4", 1000);
	RunScript( "Tankrush0",1000);
	RunScript( "Tankrush1",1000);
	RunScript( "Tankrush2",1000);
	RunScript( "DF201", 1000);
	RunScript( "DF202", 1000);
	RunScript( "DF203", 1000);
	RunScript( "DF710", 1000);
	RunScript( "DF401", 1000);
	RunScript( "DF402", 1000);
	RunScript( "DF403", 1000);
	RunScript( "DF301", 10000);
	RunScript( "DF302", 10000);
	RunScript( "DF303", 10000);
	RunScript( "DF501", 15000);
	RunScript( "DF502", 15000);
	RunScript( "DF503", 15000);
	RunScript( "Rally402", 5000);
	RunScript( "Morale300", 5000);
	RunScript( "Morale400", 5000);
	RunScript( "Morale710", 1000);
	RunScript( "Morale200", 5000);
	RunScript( "Patrol702", 2000);
	RunScript( "Morale702", 1000);
	RunScript( "Supply", 5000);
	RunScript( "LastHope", 10000);
end;	

